using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace _2024._11._28
{
    internal class Fa<T>
    {
        public Csomopont<T> Gyoker { get; set; }
        public Fa(T gyokerAdat)
        {
            Gyoker = new Csomopont<T>(gyokerAdat);
        }

        public void MelysegiBejaras(Csomopont<T> csomopont)
        {
            if (csomopont == null) return;

            Console.WriteLine(csomopont.Adat);
            foreach (var gyermek in csomopont.Gyermekek)
            {
                MelysegiBejaras(gyermek);
            }
        }

        public bool Keres(Csomopont<T> csomopont, T adat)
        {
            if (csomopont == null) return false;

            if (csomopont.Adat.Equals(adat))
            {
                return true;
            }

            foreach (var gyermek in csomopont.Gyermekek)
            {
                if (Keres(gyermek, adat))
                {
                    return true;
                }
            }
            return false;
        }
    }
}
